diff --git a/src/include/commands/vacuum_internal.h b/src/include/commands/vacuum_internal.h
new file mode 100644
index 0000000..8a132f9
--- /dev/null
+++ b/src/include/commands/vacuum_internal.h
@@ -0,0 +1,191 @@
+/*-------------------------------------------------------------------------
+ *
+ * vacuum_internal.h
+ *	  Internal declarations for lazy vacuum
+ *
+ *
+ * Portions Copyright (c) 1996-2018, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/commands/vacuum_internal.h
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#ifndef VACUUM_INTERNAL_H
+#define VACUUM_INTERNAL_H
+
+/* DSM key for parallel lazy vacuum */
+#define VACUUM_KEY_SHARED			UINT64CONST(0xFFFFFFFFFFF00001)
+#define VACUUM_KEY_VACUUM_STATS		UINT64CONST(0xFFFFFFFFFFF00002)
+#define VACUUM_KEY_INDEX_STATS	    UINT64CONST(0xFFFFFFFFFFF00003)
+#define VACUUM_KEY_DEAD_TUPLES		UINT64CONST(0xFFFFFFFFFFF00004)
+#define VACUUM_KEY_WORKERS			UINT64CONST(0xFFFFFFFFFFF00005)
+#define VACUUM_KEY_QUERY_TEXT		UINT64CONST(0xFFFFFFFFFFF00006)
+
+/*
+ * Type definitions of lazy vacuum. The fields of these structs are
+ * accessed by only the vacuum leader.
+ */
+typedef struct LVScanDescData LVScanDescData;
+typedef struct LVScanDescData *LVScanDesc;
+typedef struct LVTidMap	LVTidMap;
+typedef struct LVIndStats LVIndStats;
+
+/* Vacuum worker state for parallel lazy vacuum */
+typedef enum VacWorkerSate
+{
+	VACSTATE_INVALID = 0,
+	VACSTATE_SCAN,
+	VACSTATE_VACUUM_INDEX,
+	VACSTATE_VACUUM_HEAP,
+	VACSTATE_CLEANUP_INDEX,
+	VACSTATE_WORKER_DONE,
+	VACSTATE_COMPLETED
+} VacWorkerState;
+
+/*
+ * The 'pid' always starts with InvalidPid, which means the vacuum worker
+ * is starting up. It's sets by the vacuum worker itself during start up. When
+ * the vacuum worker exits or detaches the vacuum worker slot, 'pid' is set to 0,
+ * which means the vacuum worker is dead.
+ */
+typedef struct VacuumWorker
+{
+	pid_t			pid;	/* parallel worker's pid.
+							   InvalidPid = not started yet; 0 = dead */
+
+	VacWorkerState	state;	/* current worker's state */
+	slock_t			mutex;	/* protect the above fields */
+} VacuumWorker;
+
+/* Struct to control parallel vacuum workers */
+typedef struct LVWorkerState
+{
+	int		nparticipantvacuum;		/* only parallel worker, not including
+									   the leader */
+	int		nparticipantvacuum_launched;	/* actual launched workers of
+											   nparticipantvacuum */
+
+	/* condition variable signaled when changing status */
+	ConditionVariable	cv;
+
+	/* protect workers array */
+	LWLock				vacuumlock;
+
+	VacuumWorker workers[FLEXIBLE_ARRAY_MEMBER];
+} LVWorkerState;
+#define SizeOfLVWorkerState offsetof(LVWorkerState, workers) + sizeof(VacuumWorker)
+
+typedef struct LVRelStats
+{
+	/* hasindex = true means two-pass strategy; false means one-pass */
+	bool		hasindex;
+	/* Overall statistics about rel */
+	BlockNumber old_rel_pages;		/* previous value of pg_class.relpages */
+	BlockNumber rel_pages;			/* total number of pages */
+	BlockNumber scanned_pages;		/* number of pages we examined */
+	BlockNumber pinskipped_pages;	/* # of pages we skipped due to a pin */
+	BlockNumber frozenskipped_pages;	/* # of frozen pages we skipped */
+	BlockNumber tupcount_pages;		/* pages whose tuples we counted */
+	BlockNumber empty_pages;		/* # of empty pages */
+	BlockNumber vacuumed_pages;		/* # of pages we vacuumed */
+	double		num_tuples;			/* total number of nonremoval tuples */
+	double		live_tuples;		/* live tuples (reltuples estimate) */
+	double		tuples_deleted;		/* tuples cleaned up by vacuum */
+	double		unused_tuples;		/* unused item pointers */
+	double		old_live_tuples;	/* previous value of pg_class.reltuples */
+	double		new_rel_tuples;		/* new estimated total # of tuples */
+	double		new_live_tuples;	/* new estimated total # of live tuples */
+	double		new_dead_tuples;	/* new estimated total # of dead tuples */
+	BlockNumber pages_removed;
+	BlockNumber nonempty_pages; /* actually, last nonempty page + 1 */
+	int			num_index_scans;
+	TransactionId latestRemovedXid;
+	bool		lock_waiter_detected;
+} LVRelStats;
+
+/*
+ * Shared information among parallel workers.
+ */
+typedef struct LVShared
+{
+	/* Target relation's OID */
+	Oid		relid;
+
+	/* Options and thresholds used for lazy vacuum */
+	VacuumOption		options;
+	bool				aggressive;		/* is an aggressive vacuum? */
+	bool				is_wraparound;	/* for anti-wraparound purpose? */
+	int					elevel;			/* verbose logging */
+	TransactionId	oldestXmin;
+	TransactionId	freezeLimit;
+	MultiXactId		multiXactCutoff;
+
+	/* Vacuum delay */
+	int		cost_delay;
+	int		cost_limit;
+
+	int		max_dead_tuples_per_worker;	/* Maximum tuples each worker can have */
+	ParallelHeapScanDescData heapdesc;	/* for heap scan */
+} LVShared;
+
+/*
+ * Working state for lazy vacuum execution. LVState is used by both vacuum
+ * workers and the vacuum leader. In parallel lazy vacuum, the 'vacrelstats'
+ * for vacuum worker and the 'dead_tuples' exit in shared memory in addition
+ * to the three fields for parallel lazy vacuum: 'lvshared', 'indstats' and
+ * 'pcxt'.
+ */
+typedef struct LVState
+{
+	/* Vacuum target relation and indexes */
+	Oid			relid;
+	Relation	relation;
+	Relation	*indRels;
+	int			nindexes;
+
+	/* Used during scanning heap */
+	IndexBulkDeleteResult	**indbulkstats;
+	xl_heap_freeze_tuple	*frozen;
+	BlockNumber				next_fsm_block_to_vacuum;
+	BlockNumber				current_block; /* block number being scanned */
+	VacuumOption			options;
+	bool					is_wraparound;
+
+	/* Scan description for lazy vacuum */
+	LVScanDesc	lvscan;
+	bool		aggressive;
+
+	/* Vacuum statistics for the target table */
+	LVRelStats	*vacrelstats;
+
+	/* Dead tuple array */
+	LVTidMap	*dead_tuples;
+
+	/*
+	 * The following fields are only present when a parallel lazy vacuum
+	 * is performed.
+	 */
+	LVShared		*lvshared;	/* shared information among vacuum workers */
+	LVIndStats		*indstats;	/* shared index statistics */
+
+} LVState;
+
+extern LVWorkerState	*WorkerState;
+
+extern LVScanDesc lv_beginscan(Relation relation, LVShared *lvshared,
+							   bool aggressive, bool disable_page_skipping);
+extern void lv_endscan(LVScanDesc lvscan);
+extern int do_lazy_scan_heap(LVState *lvstate, bool *isFinished);
+extern void lazy_cleanup_all_indexes(LVState *lvstate);
+extern void lazy_vacuum_all_indexes(LVState *lvstate);
+extern void lazy_vacuum_heap(Relation onerel, LVState *lvstate);
+extern void vacuum_set_xid_limits_for_worker(TransactionId oldestxmin,
+											 TransactionId freezelimit,
+											 MultiXactId multixactcutoff);
+extern void vacuum_set_elevel_for_worker(int elevel);
+extern void lazy_space_alloc(LVState *lvstate, BlockNumber relblocks);
+
+
+#endif							/* VACUUM_INTERNAL_H */
diff --git a/src/include/nodes/parsenodes.h b/src/include/nodes/parsenodes.h
index aa4a0db..a0f9578 100644
--- a/src/include/nodes/parsenodes.h
+++ b/src/include/nodes/parsenodes.h
@@ -3147,7 +3147,7 @@ typedef struct ClusterStmt
  * and VACOPT_ANALYZE must be set in options.
  * ----------------------
  */
-typedef enum VacuumOption
+typedef enum VacuumOptionFlag
 {
 	VACOPT_VACUUM = 1 << 0,		/* do VACUUM */
 	VACOPT_ANALYZE = 1 << 1,	/* do ANALYZE */
@@ -3156,9 +3156,17 @@ typedef enum VacuumOption
 	VACOPT_FULL = 1 << 4,		/* FULL (non-concurrent) vacuum */
 	VACOPT_SKIP_LOCKED = 1 << 5,	/* skip if cannot get lock */
 	VACOPT_SKIPTOAST = 1 << 6,	/* don't process the TOAST table, if any */
-	VACOPT_DISABLE_PAGE_SKIPPING = 1 << 7	/* don't skip any pages */
+	VACOPT_DISABLE_PAGE_SKIPPING = 1 << 7,	/* don't skip any pages */
+	VACOPT_PARALLEL = 1 << 8	/* do VACUUM in parallel */
+} VacuumOptionFlag;
+
+typedef struct VacuumOption
+{
+	VacuumOptionFlag	flags;	/* OR of VacuumOptionFlag */
+	int					nworkers;	/* # of parallel vacuum workers */
 } VacuumOption;
 
+
 /*
  * Info about a single target table of VACUUM/ANALYZE.
  *
@@ -3176,9 +3184,9 @@ typedef struct VacuumRelation
 
 typedef struct VacuumStmt
 {
-	NodeTag		type;
-	int			options;		/* OR of VacuumOption flags */
-	List	   *rels;			/* list of VacuumRelation, or NIL for all */
+	NodeTag			type;
+	VacuumOption	options;		/* OR of VacuumOption flags */
+	List	   		*rels;			/* list of VacuumRelation, or NIL for all */
 } VacuumStmt;
 
 /* ----------------------
diff --git a/src/include/optimizer/planner.h b/src/include/optimizer/planner.h
index 3e733b3..20270ef 100644
--- a/src/include/optimizer/planner.h
+++ b/src/include/optimizer/planner.h
@@ -60,5 +60,6 @@ extern Expr *preprocess_phv_expression(PlannerInfo *root, Expr *expr);
 
 extern bool plan_cluster_use_sort(Oid tableOid, Oid indexOid);
 extern int	plan_create_index_workers(Oid tableOid, Oid indexOid);
+extern int	plan_lazy_vacuum_workers(Oid tableOid, int nworkers_requested);
 
 #endif							/* PLANNER_H */
diff --git a/src/include/pgstat.h b/src/include/pgstat.h
index f1c10d1..9c1d3fc 100644
--- a/src/include/pgstat.h
+++ b/src/include/pgstat.h
@@ -828,6 +828,8 @@ typedef enum
 	WAIT_EVENT_PARALLEL_BITMAP_SCAN,
 	WAIT_EVENT_PARALLEL_CREATE_INDEX_SCAN,
 	WAIT_EVENT_PARALLEL_FINISH,
+	WAIT_EVENT_PARALLEL_VACUUM_STARTUP,
+	WAIT_EVENT_PARALLEL_VACUUM,
 	WAIT_EVENT_PROCARRAY_GROUP_UPDATE,
 	WAIT_EVENT_PROMOTE,
 	WAIT_EVENT_REPLICATION_ORIGIN_DROP,
@@ -1032,13 +1034,17 @@ typedef struct PgBackendStatus
 
 	/*
 	 * Command progress reporting.  Any command which wishes can advertise
-	 * that it is running by setting st_progress_command,
+	 * that it is running by setting st_leaderpid, st_progress_command,
 	 * st_progress_command_target, and st_progress_param[].
 	 * st_progress_command_target should be the OID of the relation which the
 	 * command targets (we assume there's just one, as this is meant for
 	 * utility commands), but the meaning of each element in the
 	 * st_progress_param array is command-specific.
+	 * st_leader_pid can be used for command progress reporting of parallel
+	 * operation. Setting by the leader's pid of parallel operation we can
+	 * group them in progress reporting SQL.
 	 */
+	int			st_leader_pid;
 	ProgressCommandType st_progress_command;
 	Oid			st_progress_command_target;
 	int64		st_progress_param[PGSTAT_NUM_PROGRESS_PARAM];
@@ -1205,6 +1211,7 @@ extern const char *pgstat_get_crashed_backend_activity(int pid, char *buffer,
 									int buflen);
 extern const char *pgstat_get_backend_desc(BackendType backendType);
 
+extern void pgstat_report_leader_pid(int pid);
 extern void pgstat_progress_start_command(ProgressCommandType cmdtype,
 							  Oid relid);
 extern void pgstat_progress_update_param(int index, int64 val);
diff --git a/src/include/storage/lwlock.h b/src/include/storage/lwlock.h
index b2dcb73..fddcb54 100644
--- a/src/include/storage/lwlock.h
+++ b/src/include/storage/lwlock.h
@@ -219,6 +219,7 @@ typedef enum BuiltinTrancheIds
 	LWTRANCHE_SHARED_TUPLESTORE,
 	LWTRANCHE_TBM,
 	LWTRANCHE_PARALLEL_APPEND,
+	LWTRANCHE_PARALLEL_VACUUM,
 	LWTRANCHE_FIRST_USER_DEFINED
 }			BuiltinTrancheIds;
 
diff --git a/src/include/utils/rel.h b/src/include/utils/rel.h
index 84469f5..c3715e4 100644
--- a/src/include/utils/rel.h
+++ b/src/include/utils/rel.h
@@ -250,6 +250,7 @@ typedef struct AutoVacOpts
 	int			multixact_freeze_max_age;
 	int			multixact_freeze_table_age;
 	int			log_min_duration;
+	int			vacuum_parallel_workers;
 	float8		vacuum_scale_factor;
 	float8		analyze_scale_factor;
 } AutoVacOpts;
diff --git a/src/test/regress/sql/vacuum.sql b/src/test/regress/sql/vacuum.sql
index 9defa0d..8cb8f64 100644
--- a/src/test/regress/sql/vacuum.sql
+++ b/src/test/regress/sql/vacuum.sql
@@ -103,6 +103,9 @@ VACUUM (SKIP_LOCKED) vactst;
 VACUUM (SKIP_LOCKED, FULL) vactst;
 ANALYZE (SKIP_LOCKED) vactst;
 
+-- parallel option
+VACUUM (PARALLEL 1) vactst;
+
 DROP TABLE vaccluster;
 DROP TABLE vactst;
 DROP TABLE vacparted;
-- 
2.10.5

